
#include <stdio.h>
#include <malloc.h>

enum ErrorCode {
    OK,

    ERR_MEM,
    ERR_VALUE,
};

struct C {
    int i;
};

struct D {
    int c;
    int k;
};

static int error;


struct C *c_new(){
    struct C *retval = (struct C*)malloc(sizeof(struct C));
    retval->i = 0;
    return retval;
}

struct D *d_new(int c, int k) {
    struct D *retval = (struct D*)malloc(sizeof(struct D));
    retval->c = c;
    retval->k = k;
    if (k > 5) {
        error = ERR_VALUE;
    }
    return retval;
}

int main() {
    int retval = -1;
    struct C *c = NULL;
    struct D *d = NULL;

    c = c_new();
    if (! c) {
        printf("C malloc error\n");
        retval = ERR_MEM;
        goto cleanup;
    }

    d = d_new(7, 9);
    if (! d) {
        printf("D malloc error\n");
        retval = ERR_MEM;
        goto cleanup;
    }

    if (error != OK) {
        printf("D malloc error %d\n", error);
        retval = error;
        goto cleanup;
    }

    retval = 0;

cleanup:
    if (c) {
        free(c);
    }

    if (d) {
        free(d);
    }

    return retval;
}
